#include <ourhdr.h>
#include <math.h>
#include "myheader.h"


int fd;
int NRecord;
Indice * Ndx;
char bench [1000][20];


int main (void)
{
	int n=1, i, pos, r;

	Record cur;

	if((fd = open ("agenda.dat", O_RDWR | O_CREAT, 0664)) < 0)
		err_sys("Open file:");

	/*
	printf("inizio: %d\n", lseek(fd, 0, SEEK_CUR));
	aggiungi();

	printf("Quale record vuoi leggere? ");
	scanf("%d", pos);
	// mi posiziono sul record selezionato
	lseek( fd, (pos-1) * sizeof(Record), SEEK_SET);
	// leggo un record
	if ((n = read(fd, &cur, sizeof(Record))) < 0)
		err_sys("Reading record");

	display(cur);
	close (fd);
*/
	while (n != 0){
			printf("\n1.Cerca\n2.Aggiungi\n3.Stampa\n");
			printf("4.Crea 100.000 record\n5.Esegui benchmarck\n6.Cerca Telefono\n0.Fine\n");
			printf("Cosa vuoi fare?");
			scanf("%d",&n);
			if (n == 1)
			{
				cerca();
			}
			else if (n == 2)
			{
				aggiungi();
			}
			else if (n == 3)
			{
				stampa();
			}
			else if (n == 4)
			{
				crea(100000);
			}
			else if (n == 5)
			{
				benchmark();
			}
			else if (n == 6)
			{
				telsearch(bench);
			}
			else if (n == 7)
			{
				scelta(n);
			}
		}
}

int aggiungi ()
{
	Record a;
	struct tm nascita;
	char s [20];
	off_t pos;
	printf("Nome: ");
	scanf("%s",a.nome);
	printf("Numero Telefono: ");
	scanf("%s",a.numtel);
	printf("Numero Fax: ");
	scanf("%s",a.numfax);
	printf("Data di Nascita (GG/MM/AAAA): ");
	scanf("%s",s);
	nascita.tm_sec = 0;
	nascita.tm_min = 0;
	nascita.tm_hour = 0;
	s[2] = '\0';
	nascita.tm_mday = atoi(s);
	s[5] = '\0';
	nascita.tm_mon = atoi(&s[3]) - 1;		// mese dell'anno tra 0 e 11 (-1)
	s[10] = '\0';
	nascita.tm_year = atoi(&s[6]) - 1900; 	// anni a partire dal 1900
	nascita.tm_wday = 0;
	nascita.tm_yday = 0;
	nascita.tm_isdst = 0;

	if ((a.nascita = mktime( &nascita)) == -1)
		err_sys("Time conversion mktime");

	printf("%s", ctime( &a.nascita));

	printf("Indirizzo:");
	scanf("%s",a.indirizzo);
	if(strlen (a.nome)>0)
	{
		if((pos = lseek (fd,0,SEEK_END)) < 0)
			err_sys("Seeking:");
		printf("Scrivo in posizione %ld\n",pos);
		a.posix=pos;
		if (write (fd,&a,sizeof (Record))!=sizeof (Record))
			err_sys("Writing data:");
	}
	return pos;
}

void crea(int n) {
	int i;
	for(i = 0; i < n; i++)
		aggiungiRandom();
}


int aggiungiRandom ()
{
	Record a;
	struct tm nascita;
	char s [20];
	off_t pos;

	CreaStringaRandom(a.nome, 19);
	sprintf(a.numtel, "%ld", random());
	sprintf(a.numfax, "%ld", random());

	nascita.tm_sec = 0;
	nascita.tm_min = 0;
	nascita.tm_hour = 0;

	nascita.tm_mday = random() % 27 + 1;
	nascita.tm_mon = random() % 11;		// mese dell'anno tra 0 e 11 (-1)
	nascita.tm_year = random() % 108 + 2;   // anni a partire dal 1900
	nascita.tm_wday = 0;
	nascita.tm_yday = 0;
	nascita.tm_isdst = 0;

	if ((a.nascita = mktime( &nascita)) == -1)
		err_sys("Time conversion mktime");

	printf( "%s", ctime( &a.nascita));

	sprintf( a.indirizzo, "%ld", random());

	if((pos = lseek (fd,0,SEEK_END)) < 0)
		err_sys("Seeking:");
	printf("Scrivo in posizione %ld\n",pos);
	a.posix=pos;
	if (write (fd,&a,sizeof (Record))!=sizeof (Record))
		err_sys("Writing data:");
	return pos;
}


int cerca ()
{
	Record buf;

	char nome [20];
	printf("Nome da cercare:");
	scanf("%s",nome);
}

void PrintEntry( Record s)
{
	printf("Nome: %s\n", s.nome);
	printf("Numero Telefono: %s\n",s.numtel);
	printf("Data di nascita: %s\n", ctime(&s.nascita));
}


void stampa() {
	Record buf;
	int r;

	lseek( fd, 0, SEEK_SET);
	do
	{
		r = read (fd, &buf, sizeof(Record));
		if (r < 0 )
			err_sys("Reading");

		if (r == 0)
			break;

		PrintEntry( buf);

	} while( 1);
}


void benchmark()
{
	int n=1, i, size = 1000;
	char nome[20];
	char bench[1000][20];
	Record * rec;

	startCounting();
	n = LoadIndice(&Ndx, &NRecord);
	printResourceUsage();

	listaRicerche( bench, size);

	printf("\nInizio ricerca binaria\n");
	startCounting();
	// ricerca con indice
	for(i = 0; i < size; i++)
	{
		//	strcpy(Nomi[i], Ndx[random() % NRecord].nome);
		if ((rec = binSearch(bench[i])) ==  NULL) {
			printf("Nome: %s non trovato\n", bench[i]);
		}
		// PrintEntry( *rec);
	}
	printf("Fine ricerca binaria\n");
	printResourceUsage();

	printf("\nInizio ricerca sequenziale\n");
	startCounting();
	// ricerca sequenziale
	for(i = 0; i < size; i++)
	{
		//	strcpy(Nomi[i], Ndx[random() % NRecord].nome);
		if ((rec = RicercaSequenziale( bench[i])) == NULL) {
			printf("Nome: %s non trovato\n", bench[i]);
		}
		// PrintEntry( *rec);
	}
	printf("Fine ricerca sequenziale\n");
	printResourceUsage();
}
