/*
 * myheader.h
 *
 *  Created on: 23-apr-2009
 *      Author: cattaneo
 */
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/resource.h>


#ifndef MYHEADER_H_
#define MYHEADER_H_


typedef struct record {
	int posix;
	char nome [20];
	char numtel [20];
	char numfax [20];
	char indirizzo [30];
	time_t nascita;
} Record;

typedef struct indice {
	char nome [20];
	int posizione;
} Indice;



int aggiungi ();
int cerca ();
void stampa();
void crea(int);
int aggiungiRandom ();
void CreaStringaRandom (char A[] , int size);
int  LoadIndice( Indice** index, int * size);
Record * binSearch(char *);
Record * RicercaSequenziale( char *);

int MyCompare(void * q1, void *q2);
void listaRicerche( char Nomi[][20], int size);
int telsearch (char [][20]);

int scelta (int n);


extern int fd;
extern int NRecord;
extern 	Indice * Ndx;
extern char bench [1000][20];

#endif /* MYHEADER_H_ */
